︠9801644f-a914-4aa6-86c9-3941ce3f1691i︠
%md
## Continuité, surfaces et courbes de niveau

Soit $\mathcal{D} \subseteq \mathbb{R}^n$ une région de l'espace (on peut penser que $n=2$), et $f:\mathcal{D} \to \mathbb{R}$ une fonction. Soit en plus $\bf{a}\in \mathcal{D}$. On dit que la fonction $f(\bf{x})$ tend vers $L$ lorsque $\bf{x}$ tend vers $\bf{a}$ si pour tout réel $\epsilon > 0 $ il existe un réel $\delta >0$ tel que $|f(\bf{x}) - L| < \epsilon$ aussitôt que $|\bf{x} - \bf{a}| < \delta$. Autrement dit, la distance entre $f(\bf{x})$ et $L$ est aussi petite que l'on veut, pourvu que la distance entre $\bf{x}$ et $\bf{a}$ soit suffisament petite. On écrit dans ce cas $\displaystyle \lim_{\bf{x} \to \bf{a}} f(\bf{x} ) = L$

La fonction $f$ est continue en $\bf{a}$ si $\displaystyle \lim_{ \bf{x} \to \bf{a} } f(x)= f( \bf{a} )$. Ceci présuppose notamment que $\bf{a}$ fait partie du domaine de $f$. Ceci signifie que les valeurs de $f$ ne varient pas brusquement lorsque $\bf{x}$ varie aux alentours de $\bf{a}$. Dans le cas où $n=2$ (deux variables) l'interprétation de ceci en termes de la surface $z=f(x,y)$ est essentiellement la même que celle de la contuité d'une fonction $y=f(x)$ en termes de sa courbe : il n'y a pas de déchirures. Par ailleurs, en plusieurs variables on dispose de l'outil supplémentaire qui sont les courbes de niveau.

Voyons quelques exemples.

### Exemple 1.

On considère la fonction

$$ f(x,y) = \left\{ \begin{array}{lcl} \frac{x^2-y^2}{x^2+y^2} & \text{ si } & (x,y)\ne (0,0)\\ 0& \text{ si } & (x,y) =(0,0) \end{array}\right.$$


On voit bien qu'il y a un problème à l'origine (le 11e commandement : tu ne diviseras point par $0$).
︡066e83b8-828f-4649-b3b3-53578911549d︡{"done":true,"md":"## Continuité, surfaces et courbes de niveau\n\nSoit $\\mathcal{D} \\subseteq \\mathbb{R}^n$ une région de l'espace (on peut penser que $n=2$), et $f:\\mathcal{D} \\to \\mathbb{R}$ une fonction. Soit en plus $\\bf{a}\\in \\mathcal{D}$. On dit que la fonction $f(\\bf{x})$ tend vers $L$ lorsque $\\bf{x}$ tend vers $\\bf{a}$ si pour tout réel $\\epsilon > 0 $ il existe un réel $\\delta >0$ tel que $|f(\\bf{x}) - L| < \\epsilon$ aussitôt que $|\\bf{x} - \\bf{a}| < \\delta$. Autrement dit, la distance entre $f(\\bf{x})$ et $L$ est aussi petite que l'on veut, pourvu que la distance entre $\\bf{x}$ et $\\bf{a}$ soit suffisament petite. On écrit dans ce cas $\\displaystyle \\lim_{\\bf{x} \\to \\bf{a}} f(\\bf{x} ) = L$\n\nLa fonction $f$ est continue en $\\bf{a}$ si $\\displaystyle \\lim_{ \\bf{x} \\to \\bf{a} } f(x)= f( \\bf{a} )$. Ceci présuppose notamment que $\\bf{a}$ fait partie du domaine de $f$. Ceci signifie que les valeurs de $f$ ne varient pas brusquement lorsque $\\bf{x}$ varie aux alentours de $\\bf{a}$. Dans le cas où $n=2$ (deux variables) l'interprétation de ceci en termes de la surface $z=f(x,y)$ est essentiellement la même que celle de la contuité d'une fonction $y=f(x)$ en termes de sa courbe : il n'y a pas de déchirures. Par ailleurs, en plusieurs variables on dispose de l'outil supplémentaire qui sont les courbes de niveau.\n\nVoyons quelques exemples.\n\n### Exemple 1.\n\nOn considère la fonction\n\n$$ f(x,y) = \\left\\{ \\begin{array}{lcl} \\frac{x^2-y^2}{x^2+y^2} & \\text{ si } & (x,y)\\ne (0,0)\\\\ 0& \\text{ si } & (x,y) =(0,0) \\end{array}\\right.$$\n\n\nOn voit bien qu'il y a un problème à l'origine (le 11e commandement : tu ne diviseras point par $0$)."}
︠f5d9c455-5207-4a51-bf65-fa44b4ccdaa0si︠
var('x,y')
cm = colormaps.Blues
def c(x,y):
	return 0.7 + 0.4*(x^2- y^2)/(x^2+ y^2)
f(x,y)=(x^2-y^2)/(x^2+y^2)
S=plot3d(f(x,y), (x,-1,1), (y,-1,1), color = (c,cm))
show(S)


︡2ac88337-1510-4b1e-83f9-e82b9b977f08︡{"stdout":"(x, y)\n"}︡{"file":{"filename":"8a49f646-1953-4516-89c3-4975fb6c2a3d.sage3d","uuid":"8a49f646-1953-4516-89c3-4975fb6c2a3d"}}︡{"done":true}
︠69ccdf81-970d-438b-b579-d0482dab77c0i︠
%md
Voyons les courbes de niveau : on voit bien que si l'on se rapproche de l'origine par différentes droites, les valeurs de $f$ sont différentes aussi. La limite de $f$ en $(0,0)$ n'existe simplement pas, cette fonction ne peut pas être continue en ce point.
︡91b5baab-3d33-4959-a14f-577ae863d36a︡{"md":"Voyons les courbes de niveau : on voit bien que si l'on se rapproche de l'origine par différentes droites, les valeurs de $f$ sont différentes aussi. La limite de $f$ en $(0,0)$ n'existe simplement pas, cette fonction ne peut pas être continue en ce point.\n"}︡
︠bbf55a73-535a-4a39-bdd6-a1150feaa0dcs︠
C=contour_plot(f, (x,-1, 1), (y,-1, 1),cmap='Blues',linestyles='solid', colorbar=True)# Création du graphique des courbes de niveau.
show(C,figsize=6)
︡93f832aa-2206-4df0-8305-5d544e13b32f︡{"file":{"filename":"/home/user/.sage/temp/project-376921f2-eda3-44fc-b33d-1550746c3549/300/tmp_AF4rDs.svg","show":true,"text":null,"uuid":"e505654c-4f0f-4faa-8350-4fe1cd298455"},"once":false}︡{"done":true}
︠87ac8bd5-849d-42a5-b1d2-51929429411bs︠
cm = colormaps.Blues
def c(x,y):
	return 0.7 + 0.4*(x^2- y^2)/(x^2+ y^2)
f(x,y)=(x^2-y^2)/(x^2+y^2)
S=plot3d(f(x,y), (x,-1,1), (y,-1,1), color = (c,cm))
show(S)
︡f36dba7f-a2c3-48e4-8655-a04257daf2bf︡{"file":{"filename":"18907477-72d1-4019-81d9-fd7177cd27db.sage3d","uuid":"18907477-72d1-4019-81d9-fd7177cd27db"}}︡{"done":true}
︠63b9e5b3-a056-4d6c-9d87-2cb8e3479450i︠
%md
### Exemple 2 :
Considérons la fonction $g(x,y) = \arctan \left( \frac{y}{x}\right)$ lorsque $x\ne 0$.
La présence du $x$ au dénominateur indique qu'il y aura des problèmes pour des valeurs de $x$ très petites.
︡208e22c6-d4d1-4957-a18a-0b4b93e90cc8︡{"done":true,"md":"### Exemple 2 :\nConsidérons la fonction $g(x,y) = \\arctan \\left( \\frac{y}{x}\\right)$ lorsque $x\\ne 0$.\nLa présence du $x$ au dénominateur indique qu'il y aura des problèmes pour des valeurs de $x$ très petites."}
︠a3cc648b-b7d3-4438-9d1e-403a6e906bd5s︠
cm =colormaps.hot
def c(x,y):
	return (1/pi.n())*arctan(y/x) +1/2
g(x,y) = arctan(y/x)
S=plot3d(g(x,y),(x,-1,1),(y,-1,1),color=(c,cm))
show(S, aspect_ratio=[pi,pi,1])
︡53c29018-3511-4b2c-a236-91e6db2983de︡{"file":{"filename":"b4ff5801-a1e7-4b92-af0d-edd82febc0e7.sage3d","uuid":"b4ff5801-a1e7-4b92-af0d-edd82febc0e7"}}︡{"done":true}
︠6845ab0d-39b4-4283-ba66-96f49e6bdaaci︠
%md
### Les courbes de niveau :
$g(x,y) = c$ revient à dire $y / x \tan\left(c \right)$, ce qui donne que la courbe de niveau $c$ est la droite $y = (\tan c)x$. Voyons un peu :
︡3feb1c88-9240-4d60-923d-92d7513f0ed1︡{"done":true,"md":"### Les courbes de niveau : \n$g(x,y) = c$ revient à dire $y / x \\tan\\left(c \\right)$, ce qui donne que la courbe de niveau $c$ est la droite $y = (\\tan c)x$. Voyons un peu :"}
︠be4d4c0e-5628-4b99-afd7-a0a7980bdf0fs︠
C=contour_plot(g, (x,-1, 1), (y,-1, 1),cmap='hot',linestyles='solid', colorbar=True)
show(C)
︡b98d9c1f-393b-40f3-8ee9-d3a2e610bfdb︡{"file":{"filename":"/home/user/.sage/temp/project-376921f2-eda3-44fc-b33d-1550746c3549/300/tmp_bbeghb.svg","show":true,"text":null,"uuid":"47b1f298-e99c-491b-8147-0086f4137dc9"},"once":false}︡{"done":true}
︠2095faaa-9e26-4178-8215-5177954982eai︠
%md
### Exemple 3 :
Voyons maintenant à quoi ressemble une surface continue. Soit $h$ la fonction définie par

$$ h(x,y) = \left\{ \begin{array}{lcl} \frac{3x^2 y}{x^2+y^2} & \text{ si } & (x,y)\ne (0,0)\\ 0& \text{ si } & (x,y) =(0,0) \end{array}\right.$$

Ici on pourrait penser que le même problème que ci-haut va se présenter, mas ce n'est pas le cas, en fait, le numérateur est de degré 3, le dénominateur de degré 2. Le numérateur tend vers 0 plus vite que le dénominateur.
︡32890cd0-843b-4de5-ac9f-88160cff7c91︡{"done":true,"md":"### Exemple 3 :\nVoyons maintenant à quoi ressemble une surface continue. Soit $h$ la fonction définie par\n\n$$ h(x,y) = \\left\\{ \\begin{array}{lcl} \\frac{3x^2 y}{x^2+y^2} & \\text{ si } & (x,y)\\ne (0,0)\\\\ 0& \\text{ si } & (x,y) =(0,0) \\end{array}\\right.$$\n\nIci on pourrait penser que le même problème que ci-haut va se présenter, mas ce n'est pas le cas, en fait, le numérateur est de degré 3, le dénominateur de degré 2. Le numérateur tend vers 0 plus vite que le dénominateur."}
︠af6bda04-f50d-4cd7-b767-1931896be4d5s︠
var('x,y')
cm = colormaps.Blues
h(x,y)= 3*x^2*y/(x^2+y^2)
def c(x,y):
	return 0.5+1.5*x^2*y/(x^2+y^2+0.005)#


S=plot3d(h,(x,-1,1),(y,-1,1), color = (c,cm), opacity=1, mesh=1)
show(S)
C=contour_plot(h, (x,-1, 1), (y,-1, 1),cmap='Blues',linestyles='solid', colorbar=True)
show(C,figsize=4)
︡a107d17c-6271-486c-8efa-e254a85b08e9︡{"stdout":"(x, y)\n"}︡{"file":{"filename":"c679b9d7-ae95-4910-adf9-ff54ceb7e6c1.sage3d","uuid":"c679b9d7-ae95-4910-adf9-ff54ceb7e6c1"}}︡{"file":{"filename":"/home/user/.sage/temp/project-376921f2-eda3-44fc-b33d-1550746c3549/300/tmp_zd9Vpg.svg","show":true,"text":null,"uuid":"9665829c-871c-458d-abe2-61a27938e640"},"once":false}︡{"done":true}
︠6b08b900-b3df-4bd3-8d82-6b0834645d5c︠
︡48a75914-77db-40c2-8242-6ca10759dbb2︡
︠df147ff0-4778-488a-92e7-d286fc7c5f6ai︠
%md
### Continuité pour cet exemple :
Il n'y a pas de variation brusque du ton de bleu dans le diagramme!
︡106808dc-8473-49b5-ac6b-595be9c13161︡{"done":true,"md":"### Continuité pour cet exemple :\nIl n'y a pas de variation brusque du ton de bleu dans le diagramme!"}
︠d48c4e05-1099-431a-93dd-52c9b21d039f︠

︡8fb981ca-c340-4da6-93b8-654c0807bb6e︡
︠f1f021f2-dd6f-430f-9218-a9253aee8cb9i︠
%md
### Exemple 4

Soit maintenant la fonction définie par $\displaystyle h(x,y) = \frac{xy^2}{x^2+y^4}$ pour $(x,y)\ne (0,0)$ Nous avons vu en classe que si $\mathcal{C}_m$ est la droite de pente $m$, alors $$\lim_{\stackrel{(x,y)\to (0,0)}{\mathcal{C}_m}} f(x,y) = 0$$
mais sur la parabole $x=y^2$, la limite a une autre valeur. Ainsi, la limite de $f(x,y)$ lorsque $(x,y)$ tend vers $0$ n'existe pas. Voyons la surface, mais mieux encore, les courbes de niveau.
︡f7f9934d-5fef-4ea9-a80c-e81cb3a9292e︡{"done":true,"md":"### Exemple 4\n\nSoit maintenant la fonction définie par $\\displaystyle h(x,y) = \\frac{xy^2}{x^2+y^4}$ pour $(x,y)\\ne (0,0)$ Nous avons vu en classe que si $\\mathcal{C}_m$ est la droite de pente $m$, alors $$\\lim_{\\stackrel{(x,y)\\to (0,0)}{\\mathcal{C}_m}} f(x,y) = 0$$\nmais sur la parabole $x=y^2$, la limite a une autre valeur. Ainsi, la limite de $f(x,y)$ lorsque $(x,y)$ tend vers $0$ n'existe pas. Voyons la surface, mais mieux encore, les courbes de niveau."}
︠9b510799-cdcf-4cdf-8b24-48ee84726988s︠
var('x,y,s,t')
h(x,y)= x*y^2/(x^2+y^4)
cm = colormaps.Blues
def c(x,y):
	return 0.6+x*y^2/(x^2+y^4+0.005)# Colorier ceci pose des problèmes, à cause de la singularité.
S=plot3d(h,(x,-1,1),(y,-1,1),color = (c,cm), opacity=1, mesh=1)
show(S)
C=contour_plot(h, (x,-1, 1), (y,-1, 1),cmap='Blues',linestyles='solid', colorbar=True)
show(C,figsize=4)
︡16f783b9-89ea-4971-b36a-16698d031b8e︡{"stdout":"(x, y, s, t)\n"}︡{"file":{"filename":"32b71ccd-255f-44f4-852b-1b97681a3918.sage3d","uuid":"32b71ccd-255f-44f4-852b-1b97681a3918"}}︡{"file":{"filename":"/home/user/.sage/temp/project-376921f2-eda3-44fc-b33d-1550746c3549/300/tmp_LNbDIV.svg","show":true,"text":null,"uuid":"b037620f-d1e1-4b6f-9a6f-456e06e723fd"},"once":false}︡{"done":true}
︠a48b28c8-2479-437c-97cc-3d471418e33b︠
︡a3dc3ee5-0ce5-48e8-8af1-f98e6a50ce84︡
︠1a7454ae-4058-49b8-bbc4-8b15b471d55bi︠
%md

### Continuité?

C'est moins évident que dans les exemples précédents, mais on peut quand même voir le problème à l'origine : prés de l'origine, il y a des zones de toutes les tonalités de bleu.
︡b510d5a0-acc9-45a9-9ea0-2df6dcbba3fe︡{"done":true,"md":"\n### Continuité?\n\nC'est moins évident que dans les exemples précédents, mais on peut quand même voir le problème à l'origine : prés de l'origine, il y a des zones de toutes les tonalités de bleu."}
︠1c3c8b25-1b67-42c5-bfa8-3f62d2a0c493i︠
%md
### Exemple 5

Soit maintenant la fonction définie par $\displaystyle h(x,y) = \frac{y}{x^2+y^2}$ pour $(x,y)\ne (0,0)$ Nous avons vu en classe que les courbes de niveau sont des cercles, privés d'un point, à savoir l'origine.
Voyons les figures.

︡68979ec2-d146-42dd-834e-51c5685c827a︡{"done":true,"md":"### Exemple 5\n\nSoit maintenant la fonction définie par $\\displaystyle h(x,y) = \\frac{y}{x^2+y^2}$ pour $(x,y)\\ne (0,0)$ Nous avons vu en classe que les courbes de niveau sont des cercles, privés d'un point, à savoir l'origine.\nVoyons les figures."}
︠bb120c3f-3efd-45fc-b0e1-d8e11f3c72a8s︠
h(x,y)= y/(x^2+y^2)
cm = colormaps.Spectral
def c(x,y):
	return float(y/(x^2 + y^2+0.005))# Colorier ceci pose des problèmes, à cause de la singularité.
S=plot3d(h,(x,-1,1),(y,-1,1),color = (c,cm), opacity=1, mesh=1)
show(S, frame_aspect_ratio=[20,20,1])
C=contour_plot(h,(x,-1.5,1.5),(y,-1.5,1.5), cmap = "Spectral", 
               contours = [-2,-1, -0.5,-0.25,0,0.25,0.5,1,2], colorbar = True, 
               axes = True, 
               labels = True, label_colors='black', 
               label_inline=True, label_fontsize=8, 
               gridlines = True, axes_labels=['$x$','$y$'])
show(C,figsize=8)
︡ad5d321b-64b4-4e2e-badb-be210950bb76︡{"file":{"filename":"c7ab5014-9320-464d-9056-a83035ef4b47.sage3d","uuid":"c7ab5014-9320-464d-9056-a83035ef4b47"}}︡{"file":{"filename":"/home/user/.sage/temp/project-376921f2-eda3-44fc-b33d-1550746c3549/300/tmp_QE9sKk.svg","show":true,"text":null,"uuid":"f5539f5f-1561-40d8-a805-b0010ae2aa31"},"once":false}︡{"done":true}
︠3948bf2b-4894-452f-954f-be14a7431b84s︠
min([1,2])
︡72e156a1-acc5-4b52-8649-737fa0d5f4b3︡{"stdout":"1\n"}︡{"done":true}
︠415a0ccf-e190-4b46-9cfd-f2cc3ea12191s︠
import matplotlib.cm
matplotlib.cm.datad.keys()
var('r v')
cmsel = [matplotlib.cm.get_cmap('autumn')(_) for _ in sxrange(0,1,0.05)]
p = plot3d(0.2*(r**2 + v**2) + cos(2*r)*sin(2*v),(r,-2,2), (v,-2,2), adaptive=True, color=cmsel, plot_points=10, opacity=0.9)
p2 = sphere((0,0,0),1,color='black',opacity=0.5)
(p+p2).show(aspect_ratio=(1,1,1))
︡3b617e13-ddf8-4c0f-8381-8ba3d6a39673︡{"stdout":"[u'Spectral', u'summer', u'coolwarm', u'tab20c_r', u'Wistia_r', u'RdYlBu_r', u'Set1', u'Set2', u'Set3', u'brg_r', u'pink_r', u'Dark2', u'prism', u'PuOr_r', u'afmhot_r', u'terrain_r', u'PuBuGn_r', u'RdPu', u'gist_ncar_r', u'tab10_r', u'gist_yarg_r', u'Dark2_r', u'YlGnBu', u'RdYlBu', u'hot_r', u'gist_rainbow_r', u'copper_r', u'PuBu_r', u'cool_r', u'cool', u'gray', u'gist_stern', u'Greens_r', u'GnBu', u'gist_ncar', u'spring_r', u'gist_rainbow', u'gist_heat_r', u'Wistia', u'OrRd_r', u'CMRmap', u'tab20_r', u'bone', u'gist_stern_r', u'RdYlGn', u'Pastel2_r', u'BuGn_r', u'spring', u'terrain', u'YlOrRd_r', u'Set2_r', u'winter_r', u'tab20', u'PuBu', u'RdGy_r', u'flag_r', u'jet_r', u'RdPu_r', u'Purples_r', u'gist_yarg', u'BuGn', u'Paired_r', u'hsv_r', u'bwr', u'cubehelix', u'Greens', u'PRGn', u'gist_heat', u'Paired', u'hsv', u'Oranges_r', u'prism_r', u'tab10', u'Pastel2', u'Pastel1_r', u'Pastel1', u'gray_r', u'PuRd_r', u'Spectral_r', u'gnuplot2_r', u'gist_earth', u'YlGnBu_r', u'copper', u'gist_earth_r', u'Set3_r', u'OrRd', u'gnuplot_r', u'ocean_r', u'brg', u'gnuplot2', u'jet', u'bone_r', u'BuPu', u'Oranges', u'RdYlGn_r', u'PiYG', u'CMRmap_r', u'YlGn', u'binary_r', u'gist_gray_r', u'Accent', u'BuPu_r', u'gist_gray', u'flag', u'bwr_r', u'RdBu_r', u'BrBG', u'Reds', u'Set1_r', u'summer_r', u'GnBu_r', u'BrBG_r', u'Reds_r', u'RdGy', u'PuRd', u'Accent_r', u'Blues', u'tab20b_r', u'autumn_r', u'autumn', u'cubehelix_r', u'nipy_spectral_r', u'PRGn_r', u'Greys_r', u'pink', u'binary', u'winter', u'gnuplot', u'RdBu', u'hot', u'YlOrBr', u'coolwarm_r', u'rainbow_r', u'rainbow', u'PiYG_r', u'YlGn_r', u'Blues_r', u'YlOrBr_r', u'seismic', u'Purples', u'tab20c', u'tab20b', u'seismic_r', u'Greys', u'ocean', u'YlOrRd', u'PuOr', u'PuBuGn', u'nipy_spectral', u'afmhot']\n"}︡{"stdout":"(r, v)\n"}︡{"file":{"filename":"a4bb4101-79ce-4dc5-b14f-f914e5a69d52.sage3d","uuid":"a4bb4101-79ce-4dc5-b14f-f914e5a69d52"}}︡{"done":true}
︠d1ffc3d9-3d4c-4e29-8c82-3dd9c4c6f449︠









